// @bun
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getProtoOf = Object.getPrototypeOf;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __toESM = (mod, isNodeMode, target) => {
  target = mod != null ? __create(__getProtoOf(mod)) : {};
  const to = isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target;
  for (let key of __getOwnPropNames(mod))
    if (!__hasOwnProp.call(to, key))
      __defProp(to, key, {
        get: () => mod[key],
        enumerable: true
      });
  return to;
};
var __commonJS = (cb, mod) => () => (mod || cb((mod = { exports: {} }).exports, mod), mod.exports);

// ../../../../node_modules/slugify/slugify.js
var require_slugify = __commonJS((exports, module) => {
  (function(name, root, factory) {
    if (typeof exports === "object") {
      module.exports = factory();
      module.exports["default"] = factory();
    } else if (typeof define === "function" && define.amd) {
      define(factory);
    } else {
      root[name] = factory();
    }
  })("slugify", exports, function() {
    var charMap = JSON.parse(`{"$":"dollar","%":"percent","&":"and","<":"less",">":"greater","|":"or","\xA2":"cent","\xA3":"pound","\xA4":"currency","\xA5":"yen","\xA9":"(c)","\xAA":"a","\xAE":"(r)","\xBA":"o","\xC0":"A","\xC1":"A","\xC2":"A","\xC3":"A","\xC4":"A","\xC5":"A","\xC6":"AE","\xC7":"C","\xC8":"E","\xC9":"E","\xCA":"E","\xCB":"E","\xCC":"I","\xCD":"I","\xCE":"I","\xCF":"I","\xD0":"D","\xD1":"N","\xD2":"O","\xD3":"O","\xD4":"O","\xD5":"O","\xD6":"O","\xD8":"O","\xD9":"U","\xDA":"U","\xDB":"U","\xDC":"U","\xDD":"Y","\xDE":"TH","\xDF":"ss","\xE0":"a","\xE1":"a","\xE2":"a","\xE3":"a","\xE4":"a","\xE5":"a","\xE6":"ae","\xE7":"c","\xE8":"e","\xE9":"e","\xEA":"e","\xEB":"e","\xEC":"i","\xED":"i","\xEE":"i","\xEF":"i","\xF0":"d","\xF1":"n","\xF2":"o","\xF3":"o","\xF4":"o","\xF5":"o","\xF6":"o","\xF8":"o","\xF9":"u","\xFA":"u","\xFB":"u","\xFC":"u","\xFD":"y","\xFE":"th","\xFF":"y","\u0100":"A","\u0101":"a","\u0102":"A","\u0103":"a","\u0104":"A","\u0105":"a","\u0106":"C","\u0107":"c","\u010C":"C","\u010D":"c","\u010E":"D","\u010F":"d","\u0110":"DJ","\u0111":"dj","\u0112":"E","\u0113":"e","\u0116":"E","\u0117":"e","\u0118":"e","\u0119":"e","\u011A":"E","\u011B":"e","\u011E":"G","\u011F":"g","\u0122":"G","\u0123":"g","\u0128":"I","\u0129":"i","\u012A":"i","\u012B":"i","\u012E":"I","\u012F":"i","\u0130":"I","\u0131":"i","\u0136":"k","\u0137":"k","\u013B":"L","\u013C":"l","\u013D":"L","\u013E":"l","\u0141":"L","\u0142":"l","\u0143":"N","\u0144":"n","\u0145":"N","\u0146":"n","\u0147":"N","\u0148":"n","\u014C":"O","\u014D":"o","\u0150":"O","\u0151":"o","\u0152":"OE","\u0153":"oe","\u0154":"R","\u0155":"r","\u0158":"R","\u0159":"r","\u015A":"S","\u015B":"s","\u015E":"S","\u015F":"s","\u0160":"S","\u0161":"s","\u0162":"T","\u0163":"t","\u0164":"T","\u0165":"t","\u0168":"U","\u0169":"u","\u016A":"u","\u016B":"u","\u016E":"U","\u016F":"u","\u0170":"U","\u0171":"u","\u0172":"U","\u0173":"u","\u0174":"W","\u0175":"w","\u0176":"Y","\u0177":"y","\u0178":"Y","\u0179":"Z","\u017A":"z","\u017B":"Z","\u017C":"z","\u017D":"Z","\u017E":"z","\u018F":"E","\u0192":"f","\u01A0":"O","\u01A1":"o","\u01AF":"U","\u01B0":"u","\u01C8":"LJ","\u01C9":"lj","\u01CB":"NJ","\u01CC":"nj","\u0218":"S","\u0219":"s","\u021A":"T","\u021B":"t","\u0259":"e","\u02DA":"o","\u0386":"A","\u0388":"E","\u0389":"H","\u038A":"I","\u038C":"O","\u038E":"Y","\u038F":"W","\u0390":"i","\u0391":"A","\u0392":"B","\u0393":"G","\u0394":"D","\u0395":"E","\u0396":"Z","\u0397":"H","\u0398":"8","\u0399":"I","\u039A":"K","\u039B":"L","\u039C":"M","\u039D":"N","\u039E":"3","\u039F":"O","\u03A0":"P","\u03A1":"R","\u03A3":"S","\u03A4":"T","\u03A5":"Y","\u03A6":"F","\u03A7":"X","\u03A8":"PS","\u03A9":"W","\u03AA":"I","\u03AB":"Y","\u03AC":"a","\u03AD":"e","\u03AE":"h","\u03AF":"i","\u03B0":"y","\u03B1":"a","\u03B2":"b","\u03B3":"g","\u03B4":"d","\u03B5":"e","\u03B6":"z","\u03B7":"h","\u03B8":"8","\u03B9":"i","\u03BA":"k","\u03BB":"l","\u03BC":"m","\u03BD":"n","\u03BE":"3","\u03BF":"o","\u03C0":"p","\u03C1":"r","\u03C2":"s","\u03C3":"s","\u03C4":"t","\u03C5":"y","\u03C6":"f","\u03C7":"x","\u03C8":"ps","\u03C9":"w","\u03CA":"i","\u03CB":"y","\u03CC":"o","\u03CD":"y","\u03CE":"w","\u0401":"Yo","\u0402":"DJ","\u0404":"Ye","\u0406":"I","\u0407":"Yi","\u0408":"J","\u0409":"LJ","\u040A":"NJ","\u040B":"C","\u040F":"DZ","\u0410":"A","\u0411":"B","\u0412":"V","\u0413":"G","\u0414":"D","\u0415":"E","\u0416":"Zh","\u0417":"Z","\u0418":"I","\u0419":"J","\u041A":"K","\u041B":"L","\u041C":"M","\u041D":"N","\u041E":"O","\u041F":"P","\u0420":"R","\u0421":"S","\u0422":"T","\u0423":"U","\u0424":"F","\u0425":"H","\u0426":"C","\u0427":"Ch","\u0428":"Sh","\u0429":"Sh","\u042A":"U","\u042B":"Y","\u042C":"","\u042D":"E","\u042E":"Yu","\u042F":"Ya","\u0430":"a","\u0431":"b","\u0432":"v","\u0433":"g","\u0434":"d","\u0435":"e","\u0436":"zh","\u0437":"z","\u0438":"i","\u0439":"j","\u043A":"k","\u043B":"l","\u043C":"m","\u043D":"n","\u043E":"o","\u043F":"p","\u0440":"r","\u0441":"s","\u0442":"t","\u0443":"u","\u0444":"f","\u0445":"h","\u0446":"c","\u0447":"ch","\u0448":"sh","\u0449":"sh","\u044A":"u","\u044B":"y","\u044C":"","\u044D":"e","\u044E":"yu","\u044F":"ya","\u0451":"yo","\u0452":"dj","\u0454":"ye","\u0456":"i","\u0457":"yi","\u0458":"j","\u0459":"lj","\u045A":"nj","\u045B":"c","\u045D":"u","\u045F":"dz","\u0490":"G","\u0491":"g","\u0492":"GH","\u0493":"gh","\u049A":"KH","\u049B":"kh","\u04A2":"NG","\u04A3":"ng","\u04AE":"UE","\u04AF":"ue","\u04B0":"U","\u04B1":"u","\u04BA":"H","\u04BB":"h","\u04D8":"AE","\u04D9":"ae","\u04E8":"OE","\u04E9":"oe","\u0531":"A","\u0532":"B","\u0533":"G","\u0534":"D","\u0535":"E","\u0536":"Z","\u0537":"E'","\u0538":"Y'","\u0539":"T'","\u053A":"JH","\u053B":"I","\u053C":"L","\u053D":"X","\u053E":"C'","\u053F":"K","\u0540":"H","\u0541":"D'","\u0542":"GH","\u0543":"TW","\u0544":"M","\u0545":"Y","\u0546":"N","\u0547":"SH","\u0549":"CH","\u054A":"P","\u054B":"J","\u054C":"R'","\u054D":"S","\u054E":"V","\u054F":"T","\u0550":"R","\u0551":"C","\u0553":"P'","\u0554":"Q'","\u0555":"O''","\u0556":"F","\u0587":"EV","\u0621":"a","\u0622":"aa","\u0623":"a","\u0624":"u","\u0625":"i","\u0626":"e","\u0627":"a","\u0628":"b","\u0629":"h","\u062A":"t","\u062B":"th","\u062C":"j","\u062D":"h","\u062E":"kh","\u062F":"d","\u0630":"th","\u0631":"r","\u0632":"z","\u0633":"s","\u0634":"sh","\u0635":"s","\u0636":"dh","\u0637":"t","\u0638":"z","\u0639":"a","\u063A":"gh","\u0641":"f","\u0642":"q","\u0643":"k","\u0644":"l","\u0645":"m","\u0646":"n","\u0647":"h","\u0648":"w","\u0649":"a","\u064A":"y","\u064B":"an","\u064C":"on","\u064D":"en","\u064E":"a","\u064F":"u","\u0650":"e","\u0652":"","\u0660":"0","\u0661":"1","\u0662":"2","\u0663":"3","\u0664":"4","\u0665":"5","\u0666":"6","\u0667":"7","\u0668":"8","\u0669":"9","\u067E":"p","\u0686":"ch","\u0698":"zh","\u06A9":"k","\u06AF":"g","\u06CC":"y","\u06F0":"0","\u06F1":"1","\u06F2":"2","\u06F3":"3","\u06F4":"4","\u06F5":"5","\u06F6":"6","\u06F7":"7","\u06F8":"8","\u06F9":"9","\u0E3F":"baht","\u10D0":"a","\u10D1":"b","\u10D2":"g","\u10D3":"d","\u10D4":"e","\u10D5":"v","\u10D6":"z","\u10D7":"t","\u10D8":"i","\u10D9":"k","\u10DA":"l","\u10DB":"m","\u10DC":"n","\u10DD":"o","\u10DE":"p","\u10DF":"zh","\u10E0":"r","\u10E1":"s","\u10E2":"t","\u10E3":"u","\u10E4":"f","\u10E5":"k","\u10E6":"gh","\u10E7":"q","\u10E8":"sh","\u10E9":"ch","\u10EA":"ts","\u10EB":"dz","\u10EC":"ts","\u10ED":"ch","\u10EE":"kh","\u10EF":"j","\u10F0":"h","\u1E62":"S","\u1E63":"s","\u1E80":"W","\u1E81":"w","\u1E82":"W","\u1E83":"w","\u1E84":"W","\u1E85":"w","\u1E9E":"SS","\u1EA0":"A","\u1EA1":"a","\u1EA2":"A","\u1EA3":"a","\u1EA4":"A","\u1EA5":"a","\u1EA6":"A","\u1EA7":"a","\u1EA8":"A","\u1EA9":"a","\u1EAA":"A","\u1EAB":"a","\u1EAC":"A","\u1EAD":"a","\u1EAE":"A","\u1EAF":"a","\u1EB0":"A","\u1EB1":"a","\u1EB2":"A","\u1EB3":"a","\u1EB4":"A","\u1EB5":"a","\u1EB6":"A","\u1EB7":"a","\u1EB8":"E","\u1EB9":"e","\u1EBA":"E","\u1EBB":"e","\u1EBC":"E","\u1EBD":"e","\u1EBE":"E","\u1EBF":"e","\u1EC0":"E","\u1EC1":"e","\u1EC2":"E","\u1EC3":"e","\u1EC4":"E","\u1EC5":"e","\u1EC6":"E","\u1EC7":"e","\u1EC8":"I","\u1EC9":"i","\u1ECA":"I","\u1ECB":"i","\u1ECC":"O","\u1ECD":"o","\u1ECE":"O","\u1ECF":"o","\u1ED0":"O","\u1ED1":"o","\u1ED2":"O","\u1ED3":"o","\u1ED4":"O","\u1ED5":"o","\u1ED6":"O","\u1ED7":"o","\u1ED8":"O","\u1ED9":"o","\u1EDA":"O","\u1EDB":"o","\u1EDC":"O","\u1EDD":"o","\u1EDE":"O","\u1EDF":"o","\u1EE0":"O","\u1EE1":"o","\u1EE2":"O","\u1EE3":"o","\u1EE4":"U","\u1EE5":"u","\u1EE6":"U","\u1EE7":"u","\u1EE8":"U","\u1EE9":"u","\u1EEA":"U","\u1EEB":"u","\u1EEC":"U","\u1EED":"u","\u1EEE":"U","\u1EEF":"u","\u1EF0":"U","\u1EF1":"u","\u1EF2":"Y","\u1EF3":"y","\u1EF4":"Y","\u1EF5":"y","\u1EF6":"Y","\u1EF7":"y","\u1EF8":"Y","\u1EF9":"y","\u2013":"-","\u2018":"'","\u2019":"'","\u201C":"\\"","\u201D":"\\"","\u201E":"\\"","\u2020":"+","\u2022":"*","\u2026":"...","\u20A0":"ecu","\u20A2":"cruzeiro","\u20A3":"french franc","\u20A4":"lira","\u20A5":"mill","\u20A6":"naira","\u20A7":"peseta","\u20A8":"rupee","\u20A9":"won","\u20AA":"new shequel","\u20AB":"dong","\u20AC":"euro","\u20AD":"kip","\u20AE":"tugrik","\u20AF":"drachma","\u20B0":"penny","\u20B1":"peso","\u20B2":"guarani","\u20B3":"austral","\u20B4":"hryvnia","\u20B5":"cedi","\u20B8":"kazakhstani tenge","\u20B9":"indian rupee","\u20BA":"turkish lira","\u20BD":"russian ruble","\u20BF":"bitcoin","\u2120":"sm","\u2122":"tm","\u2202":"d","\u2206":"delta","\u2211":"sum","\u221E":"infinity","\u2665":"love","\u5143":"yuan","\u5186":"yen","\uFDFC":"rial","\uFEF5":"laa","\uFEF7":"laa","\uFEF9":"lai","\uFEFB":"la"}`);
    var locales = JSON.parse('{"bg":{"\u0419":"Y","\u0426":"Ts","\u0429":"Sht","\u042A":"A","\u042C":"Y","\u0439":"y","\u0446":"ts","\u0449":"sht","\u044A":"a","\u044C":"y"},"de":{"\xC4":"AE","\xE4":"ae","\xD6":"OE","\xF6":"oe","\xDC":"UE","\xFC":"ue","\xDF":"ss","%":"prozent","&":"und","|":"oder","\u2211":"summe","\u221E":"unendlich","\u2665":"liebe"},"es":{"%":"por ciento","&":"y","<":"menor que",">":"mayor que","|":"o","\xA2":"centavos","\xA3":"libras","\xA4":"moneda","\u20A3":"francos","\u2211":"suma","\u221E":"infinito","\u2665":"amor"},"fr":{"%":"pourcent","&":"et","<":"plus petit",">":"plus grand","|":"ou","\xA2":"centime","\xA3":"livre","\xA4":"devise","\u20A3":"franc","\u2211":"somme","\u221E":"infini","\u2665":"amour"},"pt":{"%":"porcento","&":"e","<":"menor",">":"maior","|":"ou","\xA2":"centavo","\u2211":"soma","\xA3":"libra","\u221E":"infinito","\u2665":"amor"},"uk":{"\u0418":"Y","\u0438":"y","\u0419":"Y","\u0439":"y","\u0426":"Ts","\u0446":"ts","\u0425":"Kh","\u0445":"kh","\u0429":"Shch","\u0449":"shch","\u0413":"H","\u0433":"h"},"vi":{"\u0110":"D","\u0111":"d"},"da":{"\xD8":"OE","\xF8":"oe","\xC5":"AA","\xE5":"aa","%":"procent","&":"og","|":"eller","$":"dollar","<":"mindre end",">":"st\xF8rre end"},"nb":{"&":"og","\xC5":"AA","\xC6":"AE","\xD8":"OE","\xE5":"aa","\xE6":"ae","\xF8":"oe"},"it":{"&":"e"},"nl":{"&":"en"},"sv":{"&":"och","\xC5":"AA","\xC4":"AE","\xD6":"OE","\xE5":"aa","\xE4":"ae","\xF6":"oe"}}');
    function replace(string, options) {
      if (typeof string !== "string") {
        throw new Error("slugify: string argument expected");
      }
      options = typeof options === "string" ? { replacement: options } : options || {};
      var locale = locales[options.locale] || {};
      var replacement = options.replacement === undefined ? "-" : options.replacement;
      var trim = options.trim === undefined ? true : options.trim;
      var slug = string.normalize().split("").reduce(function(result, ch) {
        var appendChar = locale[ch];
        if (appendChar === undefined)
          appendChar = charMap[ch];
        if (appendChar === undefined)
          appendChar = ch;
        if (appendChar === replacement)
          appendChar = " ";
        return result + appendChar.replace(options.remove || /[^\w\s$*_+~.()'"!\-:@]+/g, "");
      }, "");
      if (options.strict) {
        slug = slug.replace(/[^A-Za-z0-9\s]/g, "");
      }
      if (trim) {
        slug = slug.trim();
      }
      slug = slug.replace(/\s+/g, replacement);
      if (options.lower) {
        slug = slug.toLowerCase();
      }
      return slug;
    }
    replace.extend = function(customMap) {
      Object.assign(charMap, customMap);
    };
    return replace;
  });
});

// ../../../../node_modules/pluralize/pluralize.js
var require_pluralize = __commonJS((exports, module) => {
  (function(root, pluralize) {
    if (typeof import.meta.require === "function" && typeof exports === "object" && typeof module === "object") {
      module.exports = pluralize();
    } else if (typeof define === "function" && define.amd) {
      define(function() {
        return pluralize();
      });
    } else {
      root.pluralize = pluralize();
    }
  })(exports, function() {
    var pluralRules = [];
    var singularRules = [];
    var uncountables = {};
    var irregularPlurals = {};
    var irregularSingles = {};
    function sanitizeRule(rule) {
      if (typeof rule === "string") {
        return new RegExp("^" + rule + "$", "i");
      }
      return rule;
    }
    function restoreCase(word, token) {
      if (word === token)
        return token;
      if (word === word.toLowerCase())
        return token.toLowerCase();
      if (word === word.toUpperCase())
        return token.toUpperCase();
      if (word[0] === word[0].toUpperCase()) {
        return token.charAt(0).toUpperCase() + token.substr(1).toLowerCase();
      }
      return token.toLowerCase();
    }
    function interpolate(str, args) {
      return str.replace(/\$(\d{1,2})/g, function(match, index) {
        return args[index] || "";
      });
    }
    function replace(word, rule) {
      return word.replace(rule[0], function(match, index) {
        var result = interpolate(rule[1], arguments);
        if (match === "") {
          return restoreCase(word[index - 1], result);
        }
        return restoreCase(match, result);
      });
    }
    function sanitizeWord(token, word, rules) {
      if (!token.length || uncountables.hasOwnProperty(token)) {
        return word;
      }
      var len = rules.length;
      while (len--) {
        var rule = rules[len];
        if (rule[0].test(word))
          return replace(word, rule);
      }
      return word;
    }
    function replaceWord(replaceMap, keepMap, rules) {
      return function(word) {
        var token = word.toLowerCase();
        if (keepMap.hasOwnProperty(token)) {
          return restoreCase(word, token);
        }
        if (replaceMap.hasOwnProperty(token)) {
          return restoreCase(word, replaceMap[token]);
        }
        return sanitizeWord(token, word, rules);
      };
    }
    function checkWord(replaceMap, keepMap, rules, bool) {
      return function(word) {
        var token = word.toLowerCase();
        if (keepMap.hasOwnProperty(token))
          return true;
        if (replaceMap.hasOwnProperty(token))
          return false;
        return sanitizeWord(token, token, rules) === token;
      };
    }
    function pluralize(word, count, inclusive) {
      var pluralized = count === 1 ? pluralize.singular(word) : pluralize.plural(word);
      return (inclusive ? count + " " : "") + pluralized;
    }
    pluralize.plural = replaceWord(irregularSingles, irregularPlurals, pluralRules);
    pluralize.isPlural = checkWord(irregularSingles, irregularPlurals, pluralRules);
    pluralize.singular = replaceWord(irregularPlurals, irregularSingles, singularRules);
    pluralize.isSingular = checkWord(irregularPlurals, irregularSingles, singularRules);
    pluralize.addPluralRule = function(rule, replacement) {
      pluralRules.push([sanitizeRule(rule), replacement]);
    };
    pluralize.addSingularRule = function(rule, replacement) {
      singularRules.push([sanitizeRule(rule), replacement]);
    };
    pluralize.addUncountableRule = function(word) {
      if (typeof word === "string") {
        uncountables[word.toLowerCase()] = true;
        return;
      }
      pluralize.addPluralRule(word, "$0");
      pluralize.addSingularRule(word, "$0");
    };
    pluralize.addIrregularRule = function(single, plural) {
      plural = plural.toLowerCase();
      single = single.toLowerCase();
      irregularSingles[single] = plural;
      irregularPlurals[plural] = single;
    };
    [
      ["I", "we"],
      ["me", "us"],
      ["he", "they"],
      ["she", "they"],
      ["them", "them"],
      ["myself", "ourselves"],
      ["yourself", "yourselves"],
      ["itself", "themselves"],
      ["herself", "themselves"],
      ["himself", "themselves"],
      ["themself", "themselves"],
      ["is", "are"],
      ["was", "were"],
      ["has", "have"],
      ["this", "these"],
      ["that", "those"],
      ["echo", "echoes"],
      ["dingo", "dingoes"],
      ["volcano", "volcanoes"],
      ["tornado", "tornadoes"],
      ["torpedo", "torpedoes"],
      ["genus", "genera"],
      ["viscus", "viscera"],
      ["stigma", "stigmata"],
      ["stoma", "stomata"],
      ["dogma", "dogmata"],
      ["lemma", "lemmata"],
      ["schema", "schemata"],
      ["anathema", "anathemata"],
      ["ox", "oxen"],
      ["axe", "axes"],
      ["die", "dice"],
      ["yes", "yeses"],
      ["foot", "feet"],
      ["eave", "eaves"],
      ["goose", "geese"],
      ["tooth", "teeth"],
      ["quiz", "quizzes"],
      ["human", "humans"],
      ["proof", "proofs"],
      ["carve", "carves"],
      ["valve", "valves"],
      ["looey", "looies"],
      ["thief", "thieves"],
      ["groove", "grooves"],
      ["pickaxe", "pickaxes"],
      ["passerby", "passersby"]
    ].forEach(function(rule) {
      return pluralize.addIrregularRule(rule[0], rule[1]);
    });
    [
      [/s?$/i, "s"],
      [/[^\u0000-\u007F]$/i, "$0"],
      [/([^aeiou]ese)$/i, "$1"],
      [/(ax|test)is$/i, "$1es"],
      [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, "$1es"],
      [/(e[mn]u)s?$/i, "$1s"],
      [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, "$1"],
      [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1i"],
      [/(alumn|alg|vertebr)(?:a|ae)$/i, "$1ae"],
      [/(seraph|cherub)(?:im)?$/i, "$1im"],
      [/(her|at|gr)o$/i, "$1oes"],
      [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, "$1a"],
      [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, "$1a"],
      [/sis$/i, "ses"],
      [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, "$1$2ves"],
      [/([^aeiouy]|qu)y$/i, "$1ies"],
      [/([^ch][ieo][ln])ey$/i, "$1ies"],
      [/(x|ch|ss|sh|zz)$/i, "$1es"],
      [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, "$1ices"],
      [/\b((?:tit)?m|l)(?:ice|ouse)$/i, "$1ice"],
      [/(pe)(?:rson|ople)$/i, "$1ople"],
      [/(child)(?:ren)?$/i, "$1ren"],
      [/eaux$/i, "$0"],
      [/m[ae]n$/i, "men"],
      ["thou", "you"]
    ].forEach(function(rule) {
      return pluralize.addPluralRule(rule[0], rule[1]);
    });
    [
      [/s$/i, ""],
      [/(ss)$/i, "$1"],
      [/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i, "$1fe"],
      [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, "$1f"],
      [/ies$/i, "y"],
      [/\b([pl]|zomb|(?:neck|cross)?t|coll|faer|food|gen|goon|group|lass|talk|goal|cut)ies$/i, "$1ie"],
      [/\b(mon|smil)ies$/i, "$1ey"],
      [/\b((?:tit)?m|l)ice$/i, "$1ouse"],
      [/(seraph|cherub)im$/i, "$1"],
      [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, "$1"],
      [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, "$1sis"],
      [/(movie|twelve|abuse|e[mn]u)s$/i, "$1"],
      [/(test)(?:is|es)$/i, "$1is"],
      [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1us"],
      [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, "$1um"],
      [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, "$1on"],
      [/(alumn|alg|vertebr)ae$/i, "$1a"],
      [/(cod|mur|sil|vert|ind)ices$/i, "$1ex"],
      [/(matr|append)ices$/i, "$1ix"],
      [/(pe)(rson|ople)$/i, "$1rson"],
      [/(child)ren$/i, "$1"],
      [/(eau)x?$/i, "$1"],
      [/men$/i, "man"]
    ].forEach(function(rule) {
      return pluralize.addSingularRule(rule[0], rule[1]);
    });
    [
      "adulthood",
      "advice",
      "agenda",
      "aid",
      "aircraft",
      "alcohol",
      "ammo",
      "analytics",
      "anime",
      "athletics",
      "audio",
      "bison",
      "blood",
      "bream",
      "buffalo",
      "butter",
      "carp",
      "cash",
      "chassis",
      "chess",
      "clothing",
      "cod",
      "commerce",
      "cooperation",
      "corps",
      "debris",
      "diabetes",
      "digestion",
      "elk",
      "energy",
      "equipment",
      "excretion",
      "expertise",
      "firmware",
      "flounder",
      "fun",
      "gallows",
      "garbage",
      "graffiti",
      "hardware",
      "headquarters",
      "health",
      "herpes",
      "highjinks",
      "homework",
      "housework",
      "information",
      "jeans",
      "justice",
      "kudos",
      "labour",
      "literature",
      "machinery",
      "mackerel",
      "mail",
      "media",
      "mews",
      "moose",
      "music",
      "mud",
      "manga",
      "news",
      "only",
      "personnel",
      "pike",
      "plankton",
      "pliers",
      "police",
      "pollution",
      "premises",
      "rain",
      "research",
      "rice",
      "salmon",
      "scissors",
      "series",
      "sewage",
      "shambles",
      "shrimp",
      "software",
      "species",
      "staff",
      "swine",
      "tennis",
      "traffic",
      "transportation",
      "trout",
      "tuna",
      "wealth",
      "welfare",
      "whiting",
      "wildebeest",
      "wildlife",
      "you",
      /pok[e\u00E9]mon$/i,
      /[^aeiou]ese$/i,
      /deer$/i,
      /fish$/i,
      /measles$/i,
      /o[iu]s$/i,
      /pox$/i,
      /sheep$/i
    ].forEach(pluralize.addUncountableRule);
    return pluralize;
  });
});

// ../path/src/index.ts
import process2 from "process";
import os from "os";

// ../../../../node_modules/pathe/dist/shared/pathe.ff20891b.mjs
var normalizeWindowsPath = function(input = "") {
  if (!input) {
    return input;
  }
  return input.replace(/\\/g, "/").replace(_DRIVE_LETTER_START_RE, (r) => r.toUpperCase());
};
var cwd = function() {
  if (typeof process !== "undefined" && typeof process.cwd === "function") {
    return process.cwd().replace(/\\/g, "/");
  }
  return "/";
};
var normalizeString = function(path, allowAboveRoot) {
  let res = "";
  let lastSegmentLength = 0;
  let lastSlash = -1;
  let dots = 0;
  let char = null;
  for (let index = 0;index <= path.length; ++index) {
    if (index < path.length) {
      char = path[index];
    } else if (char === "/") {
      break;
    } else {
      char = "/";
    }
    if (char === "/") {
      if (lastSlash === index - 1 || dots === 1)
        ;
      else if (dots === 2) {
        if (res.length < 2 || lastSegmentLength !== 2 || res[res.length - 1] !== "." || res[res.length - 2] !== ".") {
          if (res.length > 2) {
            const lastSlashIndex = res.lastIndexOf("/");
            if (lastSlashIndex === -1) {
              res = "";
              lastSegmentLength = 0;
            } else {
              res = res.slice(0, lastSlashIndex);
              lastSegmentLength = res.length - 1 - res.lastIndexOf("/");
            }
            lastSlash = index;
            dots = 0;
            continue;
          } else if (res.length > 0) {
            res = "";
            lastSegmentLength = 0;
            lastSlash = index;
            dots = 0;
            continue;
          }
        }
        if (allowAboveRoot) {
          res += res.length > 0 ? "/.." : "..";
          lastSegmentLength = 2;
        }
      } else {
        if (res.length > 0) {
          res += `/${path.slice(lastSlash + 1, index)}`;
        } else {
          res = path.slice(lastSlash + 1, index);
        }
        lastSegmentLength = index - lastSlash - 1;
      }
      lastSlash = index;
      dots = 0;
    } else if (char === "." && dots !== -1) {
      ++dots;
    } else {
      dots = -1;
    }
  }
  return res;
};
var _DRIVE_LETTER_START_RE = /^[A-Za-z]:\//;
var _UNC_REGEX = /^[/\\]{2}/;
var _IS_ABSOLUTE_RE = /^[/\\](?![/\\])|^[/\\]{2}(?!\.)|^[A-Za-z]:[/\\]/;
var _DRIVE_LETTER_RE = /^[A-Za-z]:$/;
var _ROOT_FOLDER_RE = /^\/([A-Za-z]:)?$/;
var sep = "/";
var delimiter = ":";
var normalize = function(path) {
  if (path.length === 0) {
    return ".";
  }
  path = normalizeWindowsPath(path);
  const isUNCPath = path.match(_UNC_REGEX);
  const isPathAbsolute = isAbsolute(path);
  const trailingSeparator = path[path.length - 1] === "/";
  path = normalizeString(path, !isPathAbsolute);
  if (path.length === 0) {
    if (isPathAbsolute) {
      return "/";
    }
    return trailingSeparator ? "./" : ".";
  }
  if (trailingSeparator) {
    path += "/";
  }
  if (_DRIVE_LETTER_RE.test(path)) {
    path += "/";
  }
  if (isUNCPath) {
    if (!isPathAbsolute) {
      return `//./${path}`;
    }
    return `//${path}`;
  }
  return isPathAbsolute && !isAbsolute(path) ? `/${path}` : path;
};
var join = function(...arguments_) {
  if (arguments_.length === 0) {
    return ".";
  }
  let joined;
  for (const argument of arguments_) {
    if (argument && argument.length > 0) {
      if (joined === undefined) {
        joined = argument;
      } else {
        joined += `/${argument}`;
      }
    }
  }
  if (joined === undefined) {
    return ".";
  }
  return normalize(joined.replace(/\/\/+/g, "/"));
};
var resolve = function(...arguments_) {
  arguments_ = arguments_.map((argument) => normalizeWindowsPath(argument));
  let resolvedPath = "";
  let resolvedAbsolute = false;
  for (let index = arguments_.length - 1;index >= -1 && !resolvedAbsolute; index--) {
    const path = index >= 0 ? arguments_[index] : cwd();
    if (!path || path.length === 0) {
      continue;
    }
    resolvedPath = `${path}/${resolvedPath}`;
    resolvedAbsolute = isAbsolute(path);
  }
  resolvedPath = normalizeString(resolvedPath, !resolvedAbsolute);
  if (resolvedAbsolute && !isAbsolute(resolvedPath)) {
    return `/${resolvedPath}`;
  }
  return resolvedPath.length > 0 ? resolvedPath : ".";
};
var isAbsolute = function(p) {
  return _IS_ABSOLUTE_RE.test(p);
};
var toNamespacedPath = function(p) {
  return normalizeWindowsPath(p);
};
var _EXTNAME_RE = /.(\.[^./]+)$/;
var extname2 = function(p) {
  const match = _EXTNAME_RE.exec(normalizeWindowsPath(p));
  return match && match[1] || "";
};
var relative = function(from, to) {
  const _from = resolve(from).replace(_ROOT_FOLDER_RE, "$1").split("/");
  const _to = resolve(to).replace(_ROOT_FOLDER_RE, "$1").split("/");
  if (_to[0][1] === ":" && _from[0][1] === ":" && _from[0] !== _to[0]) {
    return _to.join("/");
  }
  const _fromCopy = [..._from];
  for (const segment of _fromCopy) {
    if (_to[0] !== segment) {
      break;
    }
    _from.shift();
    _to.shift();
  }
  return [..._from.map(() => ".."), ..._to].join("/");
};
var dirname = function(p) {
  const segments = normalizeWindowsPath(p).replace(/\/$/, "").split("/").slice(0, -1);
  if (segments.length === 1 && _DRIVE_LETTER_RE.test(segments[0])) {
    segments[0] += "/";
  }
  return segments.join("/") || (isAbsolute(p) ? "/" : ".");
};
var format = function(p) {
  const segments = [p.root, p.dir, p.base ?? p.name + p.ext].filter(Boolean);
  return normalizeWindowsPath(p.root ? resolve(...segments) : segments.join("/"));
};
var basename = function(p, extension) {
  const lastSegment = normalizeWindowsPath(p).split("/").pop();
  return extension && lastSegment.endsWith(extension) ? lastSegment.slice(0, -extension.length) : lastSegment;
};
var parse = function(p) {
  const root = normalizeWindowsPath(p).split("/").shift() || "/";
  const base = basename(p);
  const extension = extname2(base);
  return {
    root,
    dir: dirname(p),
    base,
    ext: extension,
    name: base.slice(0, base.length - extension.length)
  };
};
// ../path/src/index.ts
function actionsPath(path2) {
  return corePath(`actions/src/${path2 || ""}`);
}
function relativeActionsPath(path2) {
  return relative(projectPath(), actionsPath(path2));
}
function userActionsPath(path2) {
  return appPath(`Actions/${path2 || ""}`);
}
function userJobsPath(path2) {
  return appPath(`Jobs/${path2 || ""}`);
}
function userListenersPath(path2) {
  return appPath(`Listeners/${path2 || ""}`);
}
function userMiddlewarePath(path2) {
  return appPath(`Middleware/${path2 || ""}`);
}
function userModelsPath(path2) {
  return appPath(`Models/${path2 || ""}`);
}
function userNotificationsPath(path2) {
  return appPath(`Notifications/${path2 || ""}`);
}
function userEventsPath() {
  return appPath(`Events.ts`);
}
function aiPath(path2) {
  return corePath(`ai/${path2 || ""}`);
}
function assetsPath(path2) {
  return resourcesPath(`assets/${path2 || ""}`);
}
function aliasPath() {
  return corePath("alias/src/index.ts");
}
function buddyPath(path2, options) {
  const absolutePath = corePath(`buddy/${path2 || ""}`);
  if (options?.relative)
    return relative(process2.cwd(), absolutePath);
  return absolutePath;
}
function runtimePath(path2) {
  return frameworkPath(`buddy/${path2 || ""}`);
}
function analyticsPath(path2) {
  return corePath(`analytics/${path2 || ""}`);
}
function arraysPath(path2) {
  return corePath(`arrays/${path2 || ""}`);
}
function appPath(path2) {
  return projectPath(`app/${path2 || ""}`);
}
function authPath(path2) {
  return corePath(`auth/${path2 || ""}`);
}
function buildPath(path2) {
  return corePath(`build/${path2 || ""}`);
}
function buildEnginePath(path2) {
  return buildPath(`${path2 || ""}`);
}
function libsPath(path2) {
  return frameworkPath(`libs/${path2 || ""}`);
}
function libsEntriesPath(path2) {
  return libsPath(`entries/${path2 || ""}`);
}
function cachePath(path2) {
  return corePath(`cache/${path2 || ""}`);
}
function chatPath(path2) {
  return corePath(`chat/${path2 || ""}`);
}
function cliPath(path2) {
  return corePath(`cli/${path2 || ""}`);
}
function cloudPath(path2) {
  return corePath(`cloud/${path2 || ""}`);
}
function frameworkCloudPath(path2) {
  return frameworkPath(`cloud/${path2 || ""}`);
}
function collectionsPath(path2) {
  return corePath(`collections/${path2 || ""}`);
}
function commandsPath(path2) {
  return appPath(`Commands/${path2 || ""}`);
}
function componentsPath(path2) {
  return resourcesPath(`components/${path2 || ""}`);
}
function configPath(path2) {
  return corePath(`config/${path2 || ""}`);
}
function corePath(path2) {
  return frameworkPath(`core/${path2 || ""}`);
}
function customElementsDataPath() {
  return frameworkPath("core/custom-elements.json");
}
function databasePath(path2) {
  return corePath(`database/${path2 || ""}`);
}
function datetimePath(path2) {
  return corePath(`datetime/${path2 || ""}`);
}
function developmentPath(path2) {
  return corePath(`development/${path2 || ""}`);
}
function desktopPath(path2) {
  return corePath(`desktop/${path2 || ""}`);
}
function docsPath(path2) {
  return corePath(`docs/${path2 || ""}`);
}
function dnsPath(path2) {
  return corePath(`domains/${path2 || ""}`);
}
function emailPath(path2) {
  return notificationsPath(`email/${path2 || ""}`);
}
function enumsPath(path2) {
  return corePath(`enums/${path2 || ""}`);
}
function errorHandlingPath(path2) {
  return corePath(`error-handling/${path2 || ""}`);
}
function eventsPath(path2) {
  return corePath(`events/${path2 || ""}`);
}
function coreEnvPath(path2) {
  return corePath(`env/${path2 || ""}`);
}
function examplesPath(type) {
  return frameworkPath(`examples/${type || ""}`);
}
function fakerPath(path2) {
  return corePath(`faker/${path2 || ""}`);
}
function frameworkPath(path2, options) {
  const absolutePath = projectStoragePath(`framework/${path2 || ""}`);
  if (options?.relative)
    return relative(options.cwd || process2.cwd(), absolutePath);
  return absolutePath;
}
function healthPath(path2) {
  return corePath(`health/${path2 || ""}`);
}
function functionsPath(path2) {
  return resourcesPath(`functions/${path2 || ""}`);
}
function gitPath(path2) {
  return corePath(`git/${path2 || ""}`);
}
function langPath(path2) {
  return projectPath(`lang/${path2 || ""}`);
}
function layoutsPath(path2, options) {
  const absolutePath = resourcesPath(`layouts/${path2 || ""}`);
  if (options?.relative)
    return relative(process2.cwd(), absolutePath);
  return absolutePath;
}
function libraryEntryPath(type) {
  return libsEntriesPath(`${type}.ts`);
}
function lintPath(path2) {
  return corePath(`lint/${path2 || ""}`);
}
function listenersPath(path2) {
  return appPath(`Listeners/${path2 || ""}`);
}
function jobsPath(path2) {
  return appPath(`Jobs/${path2 || ""}`);
}
function loggingPath(path2) {
  return corePath(`logging/${path2 || ""}`);
}
function modulesPath(path2) {
  return resourcesPath(`modules/${path2 || ""}`);
}
function notificationsPath(path2) {
  return corePath(`notifications/${path2 || ""}`);
}
function ormPath(path2) {
  return corePath(`orm/${path2 || ""}`);
}
function objectsPath(path2) {
  return corePath(`objects/${path2 || ""}`);
}
function onboardingPath(path2) {
  return projectPath(`${path2 || "views/dashboard/onboarding"}`);
}
function packageJsonPath(type) {
  if (type === "vue-components")
    return frameworkPath("libs/components/vue/package.json");
  if (type === "web-components")
    return frameworkPath("libs/components/web/package.json");
  return frameworkPath(`libs/${type}/package.json`);
}
function viewsPath(path2) {
  return resourcesPath(`views/${path2 || ""}`);
}
function pathPath(path2) {
  return corePath(`path/${path2 || ""}`);
}
function paymentsPath(path2) {
  return corePath(`payments/${path2 || ""}`);
}
function projectPath(filePath = "") {
  let path2 = process2.cwd();
  while (path2.includes("storage"))
    path2 = resolve(path2, "..");
  return resolve(path2, filePath);
}
function projectConfigPath(path2) {
  return projectPath(`config/${path2 || ""}`);
}
function projectStoragePath(path2) {
  return projectPath(`storage/${path2 || ""}`);
}
function publicPath(path2) {
  return projectPath(`public/${path2 || ""}`);
}
function pushPath(path2) {
  return notificationsPath(`push/${path2 || ""}`);
}
function queryBuilderPath(path2) {
  return corePath(`query-builder/${path2 || ""}`);
}
function queuePath(path2) {
  return corePath(`queue/${path2 || ""}`);
}
function realtimePath(path2) {
  return corePath(`realtime/${path2 || ""}`);
}
function resourcesPath(path2, options) {
  const absolutePath = projectStoragePath(`resources/${path2 || ""}`);
  if (options?.relative)
    return relative(process2.cwd(), absolutePath);
  return projectPath(`resources/${path2 || ""}`);
}
function replPath(path2) {
  return corePath(`repl/${path2 || ""}`);
}
function routerPath(path2) {
  return corePath(`router/${path2 || ""}`);
}
function routesPath(path2, options) {
  const absolutePath = resourcesPath(`routes/${path2 || ""}`);
  if (options?.relative)
    return relative(process2.cwd(), absolutePath);
  return projectPath(`routes/${path2 || ""}`);
}
function searchEnginePath(path2) {
  return corePath(`search-engine/${path2 || ""}`);
}
function settingsPath(path2) {
  return projectPath(`${path2 || "views/dashboard/settings"}`);
}
function scriptsPath(path2) {
  return frameworkPath(`scripts/${path2 || ""}`);
}
function schedulerPath(path2) {
  return corePath(`scheduler/${path2 || ""}`);
}
function signalsPath(path2) {
  return corePath(`signals/${path2 || ""}`);
}
function slugPath(path2) {
  return corePath(`slug/${path2 || ""}`);
}
function smsPath(path2) {
  return notificationsPath(`sms/${path2 || ""}`);
}
function storagePath(path2) {
  return corePath(`storage/${path2 || ""}`);
}
function storesPath(path2) {
  return resourcesPath(`stores/${path2 || ""}`);
}
function securityPath(path2) {
  return corePath(`security/${path2 || ""}`);
}
function serverPath(path2) {
  return corePath(`server/${path2 || ""}`);
}
function serverlessPath(path2) {
  return corePath(`serverless/${path2 || ""}`);
}
function stacksPath(path2) {
  return frameworkPath(`src/${path2 || ""}`);
}
function shellPath(path2) {
  return corePath(`shell/${path2 || ""}`);
}
function stringsPath(path2) {
  return corePath(`strings/${path2 || ""}`);
}
function testingPath(path2) {
  return corePath(`testing/${path2 || ""}`);
}
function tinkerPath(path2) {
  return corePath(`tinker/${path2 || ""}`);
}
function testsPath(path2) {
  return frameworkPath(`tests/${path2 || ""}`);
}
function typesPath(path2) {
  return corePath(`types/${path2 || ""}`);
}
function uiPath(path2) {
  return corePath(`ui/${path2 || ""}`);
}
function utilsPath(path2) {
  return corePath(`utils/${path2 || ""}`);
}
function validationPath(path2) {
  return corePath(`validation/${path2 || ""}`);
}
function vitePath(path2) {
  return corePath(`vite/${path2 || ""}`);
}
function xRayPath(path2) {
  return frameworkPath(`stacks/x-ray/${path2 || ""}`);
}
function homeDir(path2) {
  return os.homedir() + (path2 ? (path2.startsWith("/") ? "" : "/") + path2 : "~");
}
var path2 = {
  actionsPath,
  userActionsPath,
  aiPath,
  assetsPath,
  relativeActionsPath,
  aliasPath,
  analyticsPath,
  arraysPath,
  appPath,
  authPath,
  buddyPath,
  buildEnginePath,
  libsEntriesPath,
  buildPath,
  cachePath,
  chatPath,
  cliPath,
  cloudPath,
  frameworkCloudPath,
  collectionsPath,
  commandsPath,
  componentsPath,
  configPath,
  projectConfigPath,
  corePath,
  customElementsDataPath,
  databasePath,
  datetimePath,
  developmentPath,
  desktopPath,
  docsPath,
  dnsPath,
  emailPath,
  enumsPath,
  errorHandlingPath,
  eventsPath,
  coreEnvPath,
  healthPath,
  examplesPath,
  fakerPath,
  frameworkPath,
  storagePath,
  functionsPath,
  gitPath,
  langPath,
  layoutsPath,
  libsPath,
  libraryEntryPath,
  lintPath,
  listenersPath,
  loggingPath,
  jobsPath,
  modulesPath,
  ormPath,
  objectsPath,
  onboardingPath,
  notificationsPath,
  packageJsonPath,
  viewsPath,
  pathPath,
  paymentsPath,
  projectPath,
  projectStoragePath,
  publicPath,
  pushPath,
  queryBuilderPath,
  queuePath,
  realtimePath,
  resourcesPath,
  replPath,
  routerPath,
  routesPath,
  runtimePath,
  searchEnginePath,
  schedulerPath,
  settingsPath,
  smsPath,
  signalsPath,
  slugPath,
  scriptsPath,
  securityPath,
  serverPath,
  serverlessPath,
  stacksPath,
  stringsPath,
  shellPath,
  storesPath,
  testingPath,
  testsPath,
  tinkerPath,
  typesPath,
  uiPath,
  userEventsPath,
  userJobsPath,
  userListenersPath,
  userMiddlewarePath,
  userModelsPath,
  userNotificationsPath,
  utilsPath,
  validationPath,
  vitePath,
  xRayPath,
  homeDir,
  basename,
  delimiter,
  dirname,
  extname: extname2,
  format,
  isAbsolute,
  join,
  normalize,
  normalizeString,
  parse,
  relative,
  resolve,
  sep,
  toNamespacedPath
};

// src/middleware.ts
async function importMiddlewares(directory) {
  return [directory];
}

class Middleware {
  name;
  priority;
  handle;
  constructor(data) {
    this.name = data.name;
    this.priority = data.priority;
    this.handle = data.handle;
  }
}
var middlewares = await importMiddlewares(appPath("middleware"));
// src/request.ts
class Request {
  query = {};
  params = null;
  addQuery(url) {
    this.query = Object.fromEntries(url.searchParams);
  }
  get(element) {
    return this.query[element];
  }
  all() {
    return this.query;
  }
  has(element) {
    return element in this.query;
  }
  isEmpty() {
    return Object.keys(this.query).length === 0;
  }
  extractParamsFromRoute(routePattern, pathname) {
    const pattern = new RegExp(`^${routePattern.replace(/:(\w+)/g, (match2, paramName) => `(?<${paramName}>\\w+)`)}\$`);
    const match = pattern.exec(pathname);
    if (match?.groups)
      this.params = match?.groups;
  }
  getParams(key) {
    return this.params ? this.params[key] || null : null;
  }
}
var request = new Request;
// src/server.ts
import {URL} from "url";
import process3 from "process";
import {log} from "@stacksjs/logging";
async function serve(options = {}) {
  const hostname = options.host || "localhost";
  const port = options.port || 3000;
  const development = options.debug ? true : process3.env.APP_ENV !== "production" && process3.env.APP_ENV !== "prod";
  if (options.timezone)
    process3.env.TZ = options.timezone;
  Bun.serve({
    hostname,
    port,
    development,
    fetch(req) {
      return serverResponse(req);
    }
  });
}
async function serverResponse(req) {
  log.info(`Incoming Request: ${req.method} ${req.url}`);
  log.info(`Headers: ${JSON.stringify(req.headers)}`);
  log.info(`Body: ${JSON.stringify(req.body)}`);
  const trimmedUrl = req.url.endsWith("/") && req.url.length > 1 ? req.url.slice(0, -1) : req.url;
  const routesList = await route.getRoutes();
  log.info(`Routes List: ${JSON.stringify(routesList)}`);
  const url = new URL(trimmedUrl);
  log.info(`URL: ${JSON.stringify(url)}`);
  const foundRoute = routesList.find((route2) => {
    const pattern = new RegExp(`^${route2.uri.replace(/:\w+/g, "\\w+")}\$`);
    return pattern.test(url.pathname);
  });
  log.info(`Found Route: ${JSON.stringify(foundRoute)}`);
  if (!foundRoute)
    return new Response("Pretty 404 page coming soon", { status: 404 });
  addRouteParamsAndQuery(url, foundRoute);
  executeMiddleware(foundRoute);
  return execute(foundRoute, req, { statusCode: foundRoute?.statusCode });
}
var addRouteParamsAndQuery = function(url, route2) {
  if (!isObjectNotEmpty(url.searchParams))
    request.addQuery(url);
  request.extractParamsFromRoute(route2.uri, url.pathname);
};
var executeMiddleware = function(route2) {
  const { middleware: middleware2 = null } = route2;
  if (middleware2 && middlewares && isObjectNotEmpty(middlewares)) {
    if (isString(middleware2)) {
      const middlewareItem = middlewares.find((middlewareItem2) => {
        return middlewareItem2.name === middleware2;
      });
      if (middlewareItem)
        middlewareItem.handle();
    } else {
      middleware2.forEach((m) => {
        const middlewareItem = middlewares.find((middlewareItem2) => {
          return middlewareItem2.name === m;
        });
        if (middlewareItem)
          middlewareItem.handle();
      });
    }
  }
};
var execute = function(route2, request3, { statusCode }) {
  if (!statusCode)
    statusCode = 200;
  if (route2?.method === "GET" && (statusCode === 301 || statusCode === 302)) {
    const callback = String(route2.callback);
    const response = Response.redirect(callback, statusCode);
    return noCache(response);
  }
  if (route2?.method !== request3.method)
    return new Response("Method not allowed", { status: 405 });
  if (isString(route2.callback) && extname(route2.callback) === ".html") {
    try {
      const fileContent = Bun.file(route2.callback);
      return new Response(fileContent, { headers: { "Content-Type": "text/html" } });
    } catch (error) {
      return new Response("Error reading the HTML file", { status: 500 });
    }
  }
  if (isString(route2.callback))
    return new Response(route2.callback);
  if (isFunction(route2.callback)) {
    const result = route2.callback();
    return new Response(JSON.stringify(result));
  }
  if (isObject(route2.callback))
    return new Response(JSON.stringify(route2.callback));
  return new Response("Unknown callback type.", { status: 500 });
};
var noCache = function(response) {
  response.headers.set("Cache-Control", "no-store, no-cache, must-revalidate, proxy-revalidate");
  response.headers.set("Pragma", "no-cache");
  response.headers.set("Expires", "0");
  return response;
};
var isString = function(val) {
  return typeof val === "string";
};
var isObjectNotEmpty = function(obj) {
  return Object.keys(obj).length > 0;
};
var isFunction = function(val) {
  return typeof val === "function";
};
var isObject = function(val) {
  return val !== null && typeof val === "object" && !Array.isArray(val);
};
// src/router.ts
import {log as log2} from "@stacksjs/logging";

// ../strings/src/utils.ts
var import_slugify = __toESM(require_slugify(), 1);
// ../../../../node_modules/change-case/dist/index.js
function split(value) {
  let result = value.trim();
  result = result.replace(SPLIT_LOWER_UPPER_RE, SPLIT_REPLACE_VALUE).replace(SPLIT_UPPER_UPPER_RE, SPLIT_REPLACE_VALUE);
  result = result.replace(DEFAULT_STRIP_REGEXP, "\0");
  let start = 0;
  let end = result.length;
  while (result.charAt(start) === "\0")
    start++;
  if (start === end)
    return [];
  while (result.charAt(end - 1) === "\0")
    end--;
  return result.slice(start, end).split(/\0/g);
}
function splitSeparateNumbers(value) {
  const words = split(value);
  for (let i = 0;i < words.length; i++) {
    const word = words[i];
    const match = SPLIT_SEPARATE_NUMBER_RE.exec(word);
    if (match) {
      const offset = match.index + (match[1] ?? match[2]).length;
      words.splice(i, 1, word.slice(0, offset), word.slice(offset));
    }
  }
  return words;
}
function pascalCase(input, options) {
  const [prefix, words, suffix] = splitPrefixSuffix(input, options);
  const lower = lowerFactory(options?.locale);
  const upper = upperFactory(options?.locale);
  const transform = options?.mergeAmbiguousCharacters ? capitalCaseTransformFactory(lower, upper) : pascalCaseTransformFactory(lower, upper);
  return prefix + words.map(transform).join(options?.delimiter ?? "") + suffix;
}
var lowerFactory = function(locale) {
  return locale === false ? (input) => input.toLowerCase() : (input) => input.toLocaleLowerCase(locale);
};
var upperFactory = function(locale) {
  return locale === false ? (input) => input.toUpperCase() : (input) => input.toLocaleUpperCase(locale);
};
var capitalCaseTransformFactory = function(lower, upper) {
  return (word) => `${upper(word[0])}${lower(word.slice(1))}`;
};
var pascalCaseTransformFactory = function(lower, upper) {
  return (word, index) => {
    const char0 = word[0];
    const initial = index > 0 && char0 >= "0" && char0 <= "9" ? "_" + char0 : upper(char0);
    return initial + lower(word.slice(1));
  };
};
var splitPrefixSuffix = function(input, options = {}) {
  const splitFn = options.split ?? (options.separateNumbers ? splitSeparateNumbers : split);
  const prefixCharacters = options.prefixCharacters ?? DEFAULT_PREFIX_SUFFIX_CHARACTERS;
  const suffixCharacters = options.suffixCharacters ?? DEFAULT_PREFIX_SUFFIX_CHARACTERS;
  let prefixIndex = 0;
  let suffixIndex = input.length;
  while (prefixIndex < input.length) {
    const char = input.charAt(prefixIndex);
    if (!prefixCharacters.includes(char))
      break;
    prefixIndex++;
  }
  while (suffixIndex > prefixIndex) {
    const index = suffixIndex - 1;
    const char = input.charAt(index);
    if (!suffixCharacters.includes(char))
      break;
    suffixIndex = index;
  }
  return [
    input.slice(0, prefixIndex),
    splitFn(input.slice(prefixIndex, suffixIndex)),
    input.slice(suffixIndex)
  ];
};
var SPLIT_LOWER_UPPER_RE = /([\p{Ll}\d])(\p{Lu})/gu;
var SPLIT_UPPER_UPPER_RE = /(\p{Lu})([\p{Lu}][\p{Ll}])/gu;
var SPLIT_SEPARATE_NUMBER_RE = /(\d)\p{Ll}|(\p{L})\d/u;
var DEFAULT_STRIP_REGEXP = /[^\p{L}\d]+/giu;
var SPLIT_REPLACE_VALUE = "$1\0$2";
var DEFAULT_PREFIX_SUFFIX_CHARACTERS = "";
// ../../../../node_modules/title-case/dist/index.js
var WORD_SEPARATORS = new Set(["\u2014", "\u2013", "-", "\u2015", "/"]);
var SENTENCE_TERMINATORS = new Set([".", "!", "?"]);
var TITLE_TERMINATORS = new Set([
  ...SENTENCE_TERMINATORS,
  ":",
  '"',
  "'",
  "\u201D"
]);
var SMALL_WORDS = new Set([
  "a",
  "an",
  "and",
  "as",
  "at",
  "because",
  "but",
  "by",
  "en",
  "for",
  "if",
  "in",
  "neither",
  "nor",
  "of",
  "on",
  "only",
  "or",
  "over",
  "per",
  "so",
  "some",
  "than",
  "that",
  "the",
  "to",
  "up",
  "upon",
  "v",
  "versus",
  "via",
  "vs",
  "when",
  "with",
  "without",
  "yet"
]);
// ../strings/src/pluralize.ts
var pluralize = __toESM(require_pluralize(), 1);
// src/router.ts
class Router {
  routes = [];
  apiPrefix = "/api";
  groupPrefix = "";
  path = "";
  addRoute(method, uri, callback, statusCode) {
    const name = uri.replace(/\//g, ".").replace(/:/g, "");
    const pattern = new RegExp(`^${uri.replace(/:[a-zA-Z]+/g, (_match) => {
      return "([a-zA-Z0-9-]+)";
    })}\$`);
    let routeCallback;
    if (typeof callback === "string" || typeof callback === "object") {
      routeCallback = () => callback;
    } else {
      routeCallback = callback;
    }
    log2.debug(`Adding route: ${method} ${uri} with name ${name}`);
    this.routes.push({
      name,
      method,
      url: uri,
      uri,
      callback: routeCallback,
      pattern,
      statusCode,
      paramNames: []
    });
    return this;
  }
  async get(path5, callback) {
    this.path = this.normalizePath(path5);
    log2.debug(`Normalized Path: ${this.path}`);
    callback = await this.resolveCallback(callback);
    const uri = this.prepareUri(this.path);
    log2.debug(`Prepared URI: ${uri}`);
    return this.addRoute("GET", uri, callback, 200);
  }
  async email(path5) {
    path5 = pascalCase(path5);
    const emailModule = await import(path2.userNotificationsPath(`${path5}.ts`));
    const callback = emailModule.default.handle;
    const uri = this.prepareUri(path5);
    this.addRoute("GET", uri, callback, 200);
    return this;
  }
  async health() {
    const healthModule = await import(path2.userActionsPath("HealthAction.ts"));
    const callback = healthModule.default.handle;
    const path5 = healthModule.default.path ?? `${this.apiPrefix}/health`;
    this.addRoute("GET", path5, callback, 200);
    return this;
  }
  async job(path5) {
    path5 = pascalCase(path5);
    const jobModule = await import(path2.userJobsPath(`${path5}Job.ts`.replace(/JobJob/, "Job")));
    const callback = jobModule.default.handle;
    path5 = this.prepareUri(path5);
    this.addRoute("GET", path5, callback, 200);
    return this;
  }
  async action(path5) {
    path5 = pascalCase(path5);
    const actionModule = await import(path2.userActionsPath(`${path5}Action.ts`.replace(/ActionAction/, "Action")));
    const callback = actionModule.default.handle;
    path5 = this.prepareUri(path5);
    this.addRoute("GET", path5, callback, 200);
    return this;
  }
  post(path5, callback) {
    path5 = this.prepareUri(path5);
    this.addRoute("POST", path5, callback, 201);
    return this;
  }
  view(path5, callback) {
    this.addRoute("GET", path5, callback, 200);
    return this;
  }
  redirect(path5, callback, _status) {
    this.addRoute("GET", path5, callback, 302);
    return this;
  }
  delete(path5, callback) {
    this.addRoute("DELETE", path5, callback, 204);
    return this;
  }
  patch(path5, callback) {
    this.addRoute("PATCH", path5, callback, 202);
    return this;
  }
  put(path5, callback) {
    this.addRoute("PUT", path5, callback, 202);
    return this;
  }
  group(options, callback) {
    if (typeof options === "string")
      options = options.startsWith("/") ? options.slice(1) : options;
    let cb;
    this.prepareGroupPrefix(options);
    if (typeof options === "function") {
      cb = options;
      options = {};
    }
    if (!callback)
      throw new Error("Missing callback function for your route group.");
    cb = callback;
    const { prefix, middleware: middleware2 = [] } = options;
    const originalRoutes = this.routes;
    this.routes = [];
    cb();
    this.routes.forEach((r) => {
      r.uri = `${prefix}${r.uri}`;
      if (middleware2.length)
        r.middleware = middleware2;
      originalRoutes.push(r);
      return this;
    });
    this.routes = originalRoutes;
    return this;
  }
  name(name) {
    this.routes[this.routes.length - 1].name = name;
    return this;
  }
  middleware(middleware2) {
    this.routes[this.routes.length - 1].middleware = middleware2;
    return this;
  }
  prefix(prefix) {
    this.routes[this.routes.length - 1].prefix = prefix;
    return this;
  }
  async getRoutes() {
    await import(routesPath("api.ts"));
    return this.routes;
  }
  setGroupPrefix(prefix, options = {}) {
    if (prefix !== "") {
      prefix = `/${this.groupPrefix}/${prefix}`.replace(/\/\//g, "/");
      this.groupPrefix = prefix;
      return;
    }
    const effectiveOptions = typeof options === "object" ? options : {};
    this.groupPrefix = effectiveOptions.prefix ?? prefix ?? "";
  }
  prepareGroupPrefix(options) {
    if (this.groupPrefix !== "" && typeof options !== "string")
      return this.setGroupPrefix(this.groupPrefix, options);
    if (typeof options === "string")
      return this.setGroupPrefix(options);
    return this.setGroupPrefix("", options);
  }
  async resolveCallback(callback) {
    if (callback instanceof Promise) {
      const actionModule = await callback;
      return actionModule.default;
    }
    if (typeof callback === "string")
      return this.importCallbackFromPath(callback, this.path);
    return callback;
  }
  async importCallbackFromPath(callbackPath, originalPath) {
    let modulePath = callbackPath;
    let importPathFunction = path2.appPath;
    if (callbackPath.startsWith("../"))
      importPathFunction = path2.routesPath;
    modulePath = modulePath.endsWith(".ts") ? modulePath.slice(0, -3) : modulePath;
    const actionModule = await import(importPathFunction(`${modulePath}.ts`));
    const newPath = actionModule.default.path ?? originalPath;
    this.updatePathIfNeeded(newPath, originalPath);
    return actionModule.default.handle;
  }
  normalizePath(path5) {
    return path5.endsWith("/") ? path5.slice(0, -1) : path5;
  }
  prepareUri(path5) {
    if (path5.startsWith("/"))
      path5 = path5.slice(1);
    path5 = `${this.apiPrefix}${this.groupPrefix}/${path5}`;
    return path5.endsWith("/") ? path5.slice(0, -1) : path5;
  }
  updatePathIfNeeded(newPath, originalPath) {
    if (newPath !== originalPath) {
      this.path = newPath;
    }
  }
}
var route = new Router;
export {
  serverResponse,
  serve,
  route,
  request,
  middlewares,
  Router,
  Request,
  Middleware
};
